/*
 * MGL -- MobileGear Graphic Library -
 * Copyright (C) 1998, 1999
 *      Koji Suzuki (suz@at.sakura.ne.jp)
 *      Yukihiko Sano (yukihiko@yk.rim.or.jp)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY KOJI SUZUKI AND YUKIHIKO SANO ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE TERRENCE R. LAMBERT BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include "mgl.h"


/*  pat1 |# # |  pat2 |    | pat3 |# # | pat4 |#  |
         | # #|       |#   |      |####|      | # |
                      |##  |                  |  #|
                      |### |
                      |####|
*/

struct screen pat1 = { 0, 1, 4, 2, "\xcc\x33"};
struct screen pat2 = { 0, 1, 4, 5, "\x00\xc0\xf0\xfc\xff"};
struct screen pat3 = { 0, 1, 4, 2, "\xcc\xff"};
struct screen pat4 = { 0, 1, 3, 3, "\xc0\x30\x0c"};

int main(argc, argv) {
	open_graph();
{
	int i;
	set_color(0);
	clear_screen();

	set_color(1);
	draw_rect(10,10,90,90);
	fill_rect(20,20,70,70);
	bitblt(NULL,30,30,&pat4,0,0,50,50,BLT_TILING);
	set_color(2);
	draw_rect(10+100,10,90,90);
	fill_rect(20+100,20,70,70);
	bitblt(NULL,30+100,30,&pat1,0,0,50,50,BLT_TILING);
	set_color(3);
	draw_rect(10+200,10,90,90);
	fill_rect(20+200,20,70,70);
	bitblt(NULL,30+200,30,&pat2,0,0,50,50,BLT_TILING);

	bitblt(NULL,30+300,30,&pat3,0,0,50,50,BLT_TILING);

	for (i=0; i<100; i+=5) {
		draw_line(410,10,510,10+i);
	}

	set_color(3);
	set_font(12,0);
	draw_string(30,120+40,"FONT դ ե ");
	set_font(16,0);
	draw_string(30,134+40,"FONT դ ե ");
	set_font(24,0);
	draw_string(30,152+40,"FONT դ ե ");

	set_font(12,1);
	draw_string(330,120,"FONT դ ե ");
	set_font(12,2);
	draw_string(330,140,"FONT դ ե ");

	set_font(12,3);
	set_color(1);
	draw_string(330+3,160+3,"FONT դ ե ");
	set_color(3);
	draw_string(330,160,"FONT դ ե ");
refresh();
	get_key(-1);
}
{
	int i,x,y;
	int dx,dy;
	struct screen *s = create_memscreen(12,12,NULL);
	push_screen(s);
	set_color(0);
	clear_screen();
	for (i=0; i<30; i++) {
		x = (rand() & 0x7fffffff) % 13 - 6;
		y = (rand() & 0x7fffffff) % 13 - 6;
		if ((x * x) + (y * y) < 6 * 6) {
			draw_pixel_wc(x+6,y+6,2);
		}
	}
	pop_screen();
	x = 80*256; y = 80*256;
	for (i=0; i<1000; i++) {
		bitblt(NULL,x>>8,y>>8,s,0,0,12,12,BLT_MASKING);
		dx = (y - 120*256)/32;
		dy = -(x - 120*256)/32;
		x += dx; y += dy;
	}
refresh();
        get_key(-1);
}
#if 0
	close_graph();
#else
	exit(0);
#endif
}

